<?php
/*                                                                                                                                                       
  mememe                                     ememem
    \ememememem                       ememememem/ 
     ememememememem               ememememememem  
      emememememememe           emememememememe   
         \memememememem       ememememememe/      
         emememememememe     emememememememe     
                 emememem   ememememe              
                     ememe ememe                   
                       emememe                     
                         eme
                          e  
                             
	^^ Title : Mp Order Number Validation			 
	^^ Create : 2021-10-05
	^^ For PS version 1.7
	   @author : EAGLEMEDIA.de <eagle@eaglemedia.de>
	   @copyright : EAGLEMEDIA.de	   
	   @license : See appended file licence.txt
	   @link : http://eaglemedia.de
*/ 
	# Reports for either E_ERROR | E_WARNING | 
	# E_NOTICE | Any Error
	#
	#ini_set("display_startup_errors", 1);
	#ini_set("display_errors", 1);
	#error_reporting(E_ALL);

if (!defined('_CAN_LOAD_FILES_'))
	exit;

class MpOrderNumbers extends Module
{	
    public function __construct()
	{
		$this->name = 'mpordernumbers';
        $this->tab = 'administration';
		$this->version = '1.0.3';
		$this->author = 'eaglemedia.de';
		$this->need_instance = 1;   
		$this->bootstrap = true;
        
		parent::__construct();	
		
		$this->displayName = $this->l('Mp Order Number Validation');
		$this->description = $this->l('Validation of marketplace order numbers with order numbers of shop. Only in addition to the marketplace module of Amazon, Kaufland or Magnalister!');
		$this->ps_versions_compliancy = array('min' => '1.7.0.0', 'max' => '1.7.99.99');
	}
	
    public function install()
	{		
		if (!parent::install()	            
            // hooks for v1.7.x
            OR !$this->registerHook('backOfficeHeader')
			OR !$this->registerHook('displayDashboardTop')
            OR !$this->registerHook('displayAdminAfterHeader')
			OR !$this->disableDevice(Context::DEVICE_MOBILE))
			return false;
		return true;
	}

    public function uninstall()	
	{	    
		if (!parent::uninstall())
			return false;
		return true;
	}
/*
	public function postProcess()
	{				
	}
	
	public function getContent()
	{	
	}

    public function renderForm()
	{
	}

	public function getConfigFieldsValues()
	{
	}
*/    
    #
	#
	#
	#
	#	
    
	public function getMpOrdersFieldsValues($order_mp_reference, $module)
	{        
        
        if ($module == 'amazon') 
        {
            $sql = 'SELECT * FROM `'._DB_PREFIX_.'marketplace_orders` WHERE `mp_order_id` = "'.$order_mp_reference.'"';
            $row = Db::getInstance()->getRow($sql);
            
            $ret['id_order'] = $row['id_order'];        
            $ret['id_mp'] = $row['marketplace_id'];  
            $ret['platform'] = $row['channel'];
        }
        else if ($module == 'kaufland')
        {
            $sql = 'SELECT * FROM `'._DB_PREFIX_.'real_order` WHERE `id_order_real` = "'.$order_mp_reference.'"';
            $row = Db::getInstance()->getRow($sql);
            
            $ret['id_order'] = $row['id_order'];        
            $ret['id_mp'] = !empty($row) ? '-' : ''; 
            $ret['platform'] = !empty($row) ? 'Kaufland' : '';
        }
        else if ($module == 'magnalister')                  
        {
            $sql = 'SELECT * FROM `magnalister_orders` WHERE `special` = "'.$order_mp_reference.'"';  
            $row = Db::getInstance()->getRow($sql);
            
            $ret['id_order'] = $row['current_orders_id'];        
            $ret['id_mp'] = $row['mpID'];  
            $ret['platform'] = $row['platform'];
        }
        else
            $ret = array();         
        
        return $ret;
	}	
    
	public function hookBackOfficeHeader()
	{
		$this->context->controller->addCSS($this->_path.'views/css/mpordernumbers.css', 'all');	
	}      
    
    /*
	public function hookDisplayDashboardTop()
	{
        if (!$this->isCached('mpordernumbers.tpl', $this->getCacheId('mpordernumbers.tpl')))
        { 
            $this->smarty->assign(
                array(      
                )
            );
        }

        return $this->display(__FILE__, 'views/templates/hook/mpordernumbers.tpl', $this->getCacheId('mpordernumbers.tpl'));        
    }    
    */ 
    
	public function hookDisplayAdminAfterHeader()
    {
        $this->smarty->assign(
            array(    
                'base_uri' => Tools::getHttpHost(true).__PS_BASE_URI__,
            )
        );        

        return $this->display(__FILE__, 'views/templates/hook/mpordernumbers.tpl');
    }

}
